# cellqc: standardized quality control pipeline of single-cell RNA-Seq data

Cellqc standardizes the qualiy control of single-cell RNA-Seq (scRNA) data to render clean feature count matrices from Cell Ranger outputs. Cellqc is implemented using the Snakemake workflow management system to enhance reproduciblity and scalablity of data analysis. Briefly, the QC pipeline starts from raw count feature matrices from Cell Ranger. Dropkick filters out predicted empty droplets, and SoupX purify the transcriptome measurement by substracting the background trancripts. DoubletFinder further detects the potential doublets and retain clean count feature matrices for singlets. Cell types are annotated for clean cells by a reference database using scPred.

![workflow](docs/workflow.png)

## Installation

It is easy to install cellqc via [conda](https://docs.conda.io/en/latest/miniconda.html) at https://anaconda.org/bioconda/cellqc. To use the full function of cellqc, please also install several dependencies outside conda. It is encouraged to use the C++ implementation [mamba](https://github.com/mamba-org/mamba) to speed up the installation. E.g.,

```
conda config --add channels defaults --add channels bioconda --add channels conda-forge
mamba create -n cellqc cellqc
mamba activate cellqc
Rscript -e "remotes::install_github(c('chris-mcginnis-ucsf/DoubletFinder', 'mojaveazure/seurat-disk'))"
mamba install numpy=1.21 # by dropkick
pip install dropkick
```

Dependent software are summarized below.

| Software | URL |
|-------|-------|
| DoubletFinder | https://github.com/chris-mcginnis-ucsf/DoubletFinder |
| DropletUtils | https://bioconductor.org/packages/release/bioc/html/DropletUtils.html |
| Seurat | https://satijalab.org/seurat |
| SeuratDisk | https://github.com/mojaveazure/seurat-disk |
| SoupX | https://github.com/constantAmateur/SoupX |
| scPred | https://github.com/powellgenomicslab/scPred |
| Snakemake | https://github.com/snakemake/snakemake |
| Scanpy | https://scanpy.readthedocs.io/en/stable |
| dropkick | https://github.com/KenLauLab/dropkick |

To test the installation, simply run

```
cellqc -h
```

## Run the pipeline

`Cellqc` requires a sample file for sample information and an optional configuration file for pipeline parameters.

- The sample file (e.g., `samples.txt`) is a tab-delimited file with headers: `sample`, `cellranger`, and/or `nreaction`.
    - The `sample` column is the sample ID per sample.
    - The `cellranger` is the Cell Ranger output directory. See [Cell Ranger Outputs](https://support.10xgenomics.com/single-cell-gene-expression/software/pipelines/latest/output/gex-outputs) for an example directory.
    - The optional third column `nreaction` is the number of reactions in the library preparation, which is useful to infer expected doublets for a sample with a Cell Ranger analysis using combined raw reads from multiple reactions. If the `nreaction` column is not specified in the sample file, the default 1 reaction is used for all samples.

- A configuration file is in the YAML format. It is optional. The default parameters can be used as below. See the next section for the inspection of configuration.

```
samples: samples.txt
dropkick:
  skip: false
  method: multiotsu
  numthreads: 1
filterbycount:
  mincount: 500
  minfeature: 300
  mito: 10
doubletfinder:
  findpK: false
  numthreads: 5
  pK: 0.01
scpred:
  skip: true
  reference: /path_to_reference/scPred_trainmodel_RNA_svmRadialWeights_scpred.rds
  threshold: 0.9
```

### Inspection of configuration

The configuration file is in a YAML format. An example configuration can be found at the example directory. 

1. samples

This is the record of the input sample file (e.g., `samples.txt`).

2. dropkick

This section defines parameters for empty droplet removal by dropkick.

| Parameter | Description |
|-------|-------|
| dropkick.skip | Skip [Dropkick](https://github.com/KenLauLab/dropkick) and use the estimated cells from Cell Ranger alone (using [EmptyDrops](https://support.10xgenomics.com/single-cell-gene-expression/software/pipelines/latest/algorithms/overview#cell_calling)) if set `true`. If set `false`, to estimate further empty droplets by Dropkick. Be cautious that Dropdick might predict a significant number of false negatives for a poor library. |
| dropkick.method | The thresholding method for labeling the training data for true cells, such as multiotsu, otsu, li, or mean. |
| dropkick.numthreads | Number of threads. Dropkick will use significant memory. One thread is suggested for this step. |

3. filterbycount

To filter cells by nCount, nFeature, and percentage of mitochondria reads.

| Parameter | Description |
|-------|-------|
| filterbycount.mincount | Minimum counts for a cell. |
| filterbycount.minfeature | Minimum features for a cell. |
| filterbycount.mito | Maximum percentage of mitocondria transcripts. |

4. doubletfinder

This section includes three parameters for doublet removal by DoubletFinder.

| Parameter | Description |
|-------|-------|
| doubletfinder.findpK | To estimate the neighbor size (pK) by mean-variance bimodality coefficients if `true`. If set `false`, skip the estimation and use the preset pK value. |
| doubletfinder.numthreads | Number of threads. |
| doubletfinder.pK | A preset neighbor size (pK). Will be used if `doubletfinder.findpK=false`.|

5. scpred

A pre-trained classifier for cell-type annotation by scPred.

| Parameter | Description |
|-------|-------|
| scpred.skip | Skip the automated cell type prediction by scPred if `true`. This is useful for a sample without a pre-trained reference. |
| scpred.reference | The pre-trained reference classifier saved in a RDS file. See https://github.com/powellgenomicslab/scPred |
| scpred.threshold | Threshold for a positive prediction. |

### Result files

Three result files are generated under a `result` subdirectory. `result/*.h5seurat` and `result/*.h5ad` files are count matrices after processing with QC metrics such as "pANN" for proportion of artificial nearest neighbors, and/or "scpred_prediction" for predicted cell type. A report file `result/qc_report.html` is a summary of QC metrics.

### An example

This example demonstrates the pipeline on two AMD samples. The test data consists of Cell Ranger output directories of two AMD samples, as well as a pretrained calssifier for cell-type annotation.

https://bcm.box.com/s/nnlmgxh8avagje93cih20g1dsxx14if4

After feeding the file locations, a sample file (e.g., `samples.txt`) looks like below.

```samples.txt
sample	cellranger
AMD1	/path/to/cellranger/AMD1/outs
AMD2	/path/to/cellranger/AMD2/outs
```

Below command is to run the pipeline by the installed entrypoint `cellqc`.

```
cellqc -d "$outdir" -t 8 -- samples.txt # with default parameters
cellqc -d "$outdir" -t 8 -c config.yaml -- samples.txt # by customized parameters in config.yaml
```

A directed acyclic graph (DAG) of jobs will be generated. For example,

![DAG](docs/tests/dag.png)

A report of result files will be also produced, such as [report.html](https://github.com/lijinbio/cellqc/blob/master/docs/tests/report.html).

# vim: set noexpandtab tabstop=2:

suppressPackageStartupMessages(library(Seurat))
suppressPackageStartupMessages(library(ggplot2))
suppressPackageStartupMessages(library(SeuratDisk))

infile=snakemake@input[[1]]
outdir=snakemake@output[[1]]
mincount=snakemake@params[['mincount']]
minfeature=snakemake@params[['minfeature']]
mito=snakemake@params[['mito']]
sampleid=snakemake@params[['sampleid']]
outfile=snakemake@output[[2]]
statfile=snakemake@output[[3]]

if (endsWith(infile, '.h5')) {
	x=Read10X_h5(infile)
	x=CreateSeuratObject(counts=x)
} else if (endsWith(infile, '.rds')) {
	x=readRDS(infile)
} else if (endsWith(infile, '.h5seurat')) {
	x=LoadH5Seurat(infile, assay='RNA')
} else {
	write('Error: wrong infile. Please input either .rds or .h5seurat file\n', stderr())
	q(status=1)
}

if (!dir.exists(outdir)) {
	dir.create(outdir)
}

x[['percent.mt']]=PercentageFeatureSet(x, pattern='^MT-|^mt-')

Idents(x)=sampleid
p=VlnPlot(x, features=c('nCount_RNA', 'nFeature_RNA', 'percent.mt'), ncol=3, log=F, pt.size=0) + NoLegend()
ggsave(p, file=sprintf('%s/feature_bf.pdf', outdir), width=9, height=7.5, units='in', useDingbats=F)

ncell_bf=ncol(x)
x=subset(x, subset=nCount_RNA>=mincount & nFeature_RNA>=minfeature & percent.mt<=mito)
ncell_af=ncol(x)

p=VlnPlot(x, features=c('nCount_RNA', 'nFeature_RNA', 'percent.mt'), ncol=3, log=F, pt.size=0) + NoLegend()
ggsave(p, file=sprintf('%s/feature_af.pdf', outdir), width=9, height=7.5, units='in', useDingbats=F)

utils::write.table(data.frame(sampleid=sampleid, ncell_bf=ncell_bf, ncell_af=ncell_af), file=statfile, quote=F, sep='\t', row.names=F, col.names=T)
SaveH5Seurat(x, outfile)

# vim: set noexpandtab tabstop=2:

suppressPackageStartupMessages(library(Seurat))
suppressPackageStartupMessages(library(dplyr))
suppressPackageStartupMessages(library(ggplot2))
suppressPackageStartupMessages(library(scPred))
suppressPackageStartupMessages(library(SeuratDisk))

seuratdimplotgroupby=function(data, reduct='umap', group='cluster', label=T, repel=T, outfile, width=6, height=5) {
	x=Seurat::DimPlot(data, reduction=reduct, group.by=group, label=label, repel=repel)
	if (endsWith(outfile, '.pdf')) {
		pdf(outfile, width=width, height=height)
		print(x)
		dev.off()
	} else if (endsWith(outfile, '.png')) {
		png(outfile, width=width, height=height, units='in', res=500)
		print(x)
		dev.off()
	}
}
write.txt=function(..., file=stdout(), quote=F, sep='\t', row.names=F, col.names=T) {
	if (is.character(file) && endsWith(file, '.gz')) {
		file=gzfile(file)
	}
	utils::write.table(..., file=file, quote=quote, sep=sep, row.names=row.names, col.names=col.names)
}
seuratfeatureplot=function(data, features, slot='data', color=c('blue', 'white', 'red'), outfile, width=6, height=5) {
	x=Seurat::FeaturePlot(data, features, slot=slot) + ggplot2::scale_colour_gradientn(colours=color)
	if (endsWith(outfile, '.pdf')) {
		pdf(outfile, width=width, height=height)
		print(x)
		dev.off()
	} else if (endsWith(outfile, '.png')) {
		png(outfile, width=width, height=height, units='in', res=500)
		print(x)
		dev.off()
	}
}

infile=snakemake@input[[1]]
outdir=snakemake@output[[1]]
resultfile=snakemake@output[[2]]
contingencyfile=snakemake@output[[3]]

if (!dir.exists(outdir)) {
	dir.create(outdir)
}

if (endsWith(infile, '.h5')) {
	x=Read10X_h5(infile)
	x=CreateSeuratObject(counts=x)
} else if (endsWith(infile, '.rds')) {
	x=readRDS(infile)
} else if (endsWith(infile, '.h5seurat')) {
	x=LoadH5Seurat(infile, assay='RNA')
} else {
	write('Error: wrong infile. Please input either .rds or .h5seurat file\n', stderr())
	q(status=1)
}
x=x %>% NormalizeData() %>% FindVariableFeatures() %>% ScaleData() %>% RunPCA() %>% RunTSNE() %>% RunUMAP(dims=1:30) %>% FindNeighbors(dims=1:30) %>% FindClusters()

seuratdimplotgroupby(x, reduct='pca', group='seurat_clusters', outfile=sprintf('%s/cluster_pca.png', outdir))
seuratdimplotgroupby(x, reduct='tsne', group='seurat_clusters', outfile=sprintf('%s/cluster_tsne.png', outdir))
seuratdimplotgroupby(x, reduct='umap', group='seurat_clusters', outfile=sprintf('%s/cluster_umap.png', outdir))

ref=readRDS(snakemake@params[['ref']])
x=scPredict(x, ref, threshold=snakemake@params[['threshold']])
seuratdimplotgroupby(x, reduct='scpred', group='scpred_prediction', outfile=sprintf('%s/predict_scpred.png', outdir))
seuratdimplotgroupby(x, reduct='umap', group='scpred_prediction', outfile=sprintf('%s/predict_umap.png', outdir))

metadata=x@meta.data
write.txt(data.frame(barcode=rownames(metadata), metadata), file=sprintf('%s/metadata.txt.gz', outdir))
features=c('nCount_RNA', 'nFeature_RNA', setdiff(grep('^scpred_', names(metadata), value=T), c('scpred_prediction', 'scpred_no_rejection')))
invisible(
	lapply(features
		, function(feature) {
			seuratfeatureplot(x, features=feature, outfile=sprintf('%s/feature_%s.png', outdir, feature))
		})
	)
tmp=crossTab(x, 'seurat_clusters', 'scpred_prediction')
write.txt(cbind(cluster=rownames(tmp), tmp) , file=contingencyfile)

x=CreateSeuratObject(counts=x[['RNA']]@counts, meta.data=x@meta.data)
SaveH5Seurat(x, resultfile)

suppressPackageStartupMessages(library(SoupX))
suppressPackageStartupMessages(library(DropletUtils))

x=load10X(snakemake@input[[1]])
pdf(snakemake@output[[1]], width=6, height=4)
x=autoEstCont(x)
dev.off()
utils::write.table(data.frame(sampleid=snakemake@params[['sampleid']], rhoEst=x$fit$rhoEst), file=snakemake@output[[2]], quote=F, sep='\t', row.names=F, col.names=T)

x=adjustCounts(x, roundToInt=T)
write10xCounts(snakemake@output[[3]], x)

suppressPackageStartupMessages(library(DropletUtils))

x=read10xCounts(snakemake@input[[1]], col.names=T)
f=read.table(snakemake@input[[2]], header=T)
f=subset(f, dropkick_label=='True')
ids=f[, 'barcode']

res=data.frame(
	sampleid=snakemake@params[['sampleid']]
	, emptydrops=ncol(x)
	, dropkick=length(ids)
	, intersection=length(intersect(ids, colnames(x)))
	)
write.table(res, file=snakemake@output[[1]], quote=F, sep='\t', row.names=F, col.names=T)

x=x[, intersect(ids, colnames(x)), drop=F]
x=counts(x)
write10xCounts(snakemake@output[[2]], x)

# vim: set noexpandtab tabstop=2:

suppressPackageStartupMessages(library(Seurat))
suppressPackageStartupMessages(library(SeuratDisk))
suppressPackageStartupMessages(library(dplyr))
suppressPackageStartupMessages(library(DoubletFinder))
suppressPackageStartupMessages(library(ggplot2))

infile=snakemake@input[[1]]
outdir=snakemake@output[[1]]
statfile=snakemake@output[[3]]
sampleid=snakemake@params[['sampleid']]

if (endsWith(infile, '.h5')) {
	x=Read10X_h5(infile)
	x=CreateSeuratObject(counts=x)
} else if (endsWith(infile, '.rds')) {
	x=readRDS(infile)
} else if (endsWith(infile, '.h5seurat')) {
	x=LoadH5Seurat(infile, assay='RNA')
} else {
	write('Error: wrong infile. Please input either .rds or .h5seurat file\n', stderr())
	q(status=1)
}

x=x %>% NormalizeData() %>% FindVariableFeatures(selection.method='vst', nfeatures=2000) %>% ScaleData() %>% RunPCA() %>% RunTSNE() %>% RunUMAP(dims=1:30)

if (!dir.exists(outdir)) {
	dir.create(outdir)
}

if (snakemake@params[['findpK']]) {
	sweepx=paramSweep_v3(x, PCs=1:10, sct=F, num.cores=snakemake@params[['numthreads']])
	sweepstats=summarizeSweep(sweepx, GT=F)
	pdf(sprintf('%s/findpK_bcmetric_raw.pdf', outdir), width=8, height=7.5)
	bcmetric=find.pK(sweepstats)
	dev.off()
	write.table(bcmetric, file=gzfile(sprintf('%s/findpK_bcmetric.txt.gz', outdir)), quote=F, sep='\t', row.names=F, col.names=T)
	bcmetric$pK=as.numeric(levels(bcmetric$pK))[bcmetric$pK]

	p=ggplot(data=bcmetric, aes(x=pK, y=BCmetric)) +
	geom_line(color='blue') +
	geom_point(color='blue') +
	scale_x_continuous(breaks=scales::pretty_breaks(n=10)) +
	scale_y_continuous(breaks=scales::pretty_breaks(n=10)) +
	xlab('pK') +
	ylab('Mean-variance-normalized bimodality coefficient (meanBC/varBC)') +
	ggtitle('') +
	theme_bw() +
	theme(
		plot.background=element_blank()
		, panel.grid.major=element_blank()
		, panel.grid.minor=element_blank()
		, panel.border=element_blank()
		, plot.title=element_text(hjust=0.5)
		, axis.line=element_line(color='black')
		, axis.text=element_text(color='black')
		, legend.title=element_blank()
		, legend.position='right'
		)
	ggsave(p, file=sprintf('%s/findpK_bcmetric.pdf', outdir), width=6, height=5, units='in', useDingbats=F)
	pKopt=bcmetric$pK[which.max(bcmetric[, 'BCmetric'])]
} else {
	pKopt=snakemake@params[['pK']]
}

nreaction=snakemake@params[['nreaction']]
doubletratio=round(ncol(x)*0.1/(nreaction*13000), digits=2)
nExp_poi=round(doubletratio*ncol(x))
cat(sprintf('%s: expected %f of %d cells is %d\n', sampleid, doubletratio, ncol(x), nExp_poi))
utils::write.table(
	data.frame(
		sampleid=sampleid
		, doubletratio=doubletratio
		, ncell_bf=ncol(x)
		, nExpdoublet=nExp_poi
		, ncell_af=ncol(x)-nExp_poi
		)
	, file=statfile
	, quote=F
	, sep='\t'
	, row.names=F
	, col.names=T
	)

res=doubletFinder_v3(x, PCs=1:10, pN=0.25, pK=pKopt, nExp=nExp_poi, reuse.pANN=F, sct=F)

metadata=res@meta.data
header=names(metadata)
value=header[pmatch('pANN', header)]
group=header[pmatch('DF.classifications', header)]
metadata[, group]=factor(metadata[, group], c('Singlet', 'Doublet'))

p=ggplot(data=metadata, aes_q(x=as.name(group), y=as.name(value), fill=as.name(group))) +
geom_violin(trim=T, show.legend=F) +
geom_boxplot(width=0.1, fill='white', outlier.shape=NA) +
xlab('') +
ylab('pANN') +
ggtitle(value) +
theme_bw() +
theme(
	plot.background=element_blank()
	, panel.grid.major=element_blank()
	, panel.grid.minor=element_blank()
	, panel.border=element_blank()
	, plot.title=element_text(hjust=0.5)
	, axis.line=element_line(color='black')
	, axis.text=element_text(color='black')
	, legend.title=element_blank()
	, legend.position='right'
	, axis.text.x=element_text(angle=45, vjust=1, hjust=1)
	)
ggsave(p, file=sprintf('%s/pANN_violin_pK%s.pdf', outdir, pKopt), width=6, height=5, units='in', useDingbats=F)

pdf(sprintf('%s/umap_doublet_pK%s.pdf', outdir, pKopt), width=8, height=7.5)
print(DimPlot(res, reduction='umap', group.by=group))
dev.off()

pdf(sprintf('%s/tsne_doublet_pK%s.pdf', outdir, pKopt), width=8, height=7.5)
print(DimPlot(res, reduction='tsne', group.by=group))
dev.off()

res$pANN=res@meta.data[, value]
res$DF.classifications=res@meta.data[, group]
utils::write.table(
	data.frame(barcode=rownames(res@meta.data), res@meta.data)
	, file=gzfile(sprintf('%s/doubletfinder_pK%s_metadata.txt.gz', outdir, pKopt))
	, quote=F
	, sep='\t'
	, row.names=F
	, col.names=T
	)

res=subset(res, cells=rownames(res@meta.data)[res@meta.data[, group]=='Singlet'])
x=CreateSeuratObject(counts=res[['RNA']]@counts, meta.data=res@meta.data)
SaveH5Seurat(x, file=snakemake@output[[2]])
